package com.gic.haoban.manage.service.service;

import java.util.List;
import java.util.Set;

import com.gic.haoban.manage.api.dto.StaffClerkRelationDTO;
import org.apache.ibatis.annotations.Param;

public interface StaffClerkRelationService {

	List<StaffClerkRelationDTO> listBindCode(String enterpriseId, Set<String> clerkCodeList);

	List<StaffClerkRelationDTO> listBindCodeByStaffId(List<String> enterpriseIdList, String staffId);

	/**
	 * 删除绑定
	 * @param clerkId
	 * @return
	 */
	public boolean delBind(String clerkId);

	/**
	 * 绑定
	 * @param dto
	 * @return
	 */
	public boolean bind(StaffClerkRelationDTO dto);

	/**
	 * 根据clerkId 更新数据
	 * @param dto
	 * @return
	 */
	public boolean updateByClerkId(StaffClerkRelationDTO dto);

	/**
	 * 查询绑定根据clerkId
	 * @param clerkId
	 * @param wxEnterpriseId
	 * @return
	 */
	public StaffClerkRelationDTO getBindByClerkId(String clerkId,String wxEnterpriseId);
	
	StaffClerkRelationDTO getByCodeAndEnterpriseId(String clerkCode, String enterpriseId);

	String insert(StaffClerkRelationDTO staffClerkRelation);

	public int cleanStaffClerk(@Param("wxEnterpriseId") String wxEnterpriseId,@Param("staffIds") List<String> staffIds);

}
