package com.gic.haoban.manage.service.service.impl;

import java.util.Date;
import java.util.List;
import java.util.Set;

import com.alibaba.fastjson.JSONObject;
import com.gic.commons.util.ToolUtil;
import com.gic.haoban.manage.service.entity.TabHaobanStaffClerkRelation;

import javafx.scene.control.Tab;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.api.dto.StaffClerkRelationDTO;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanStaffClerkRelationMapper;
import com.gic.haoban.manage.service.service.StaffClerkRelationService;

@Service
public class StaffClerkRelationServiceImpl implements StaffClerkRelationService {

	private static final Logger logger= LoggerFactory.getLogger(StaffClerkRelationServiceImpl.class);

	@Autowired
	private TabHaobanStaffClerkRelationMapper mapper;
	@Override
	public List<StaffClerkRelationDTO> listBindCode(String enterpriseId, Set<String> clerkCodeList) {
		return EntityUtil.changeEntityListByJSON(StaffClerkRelationDTO.class, mapper.listBindCode(enterpriseId,clerkCodeList));
	}
	@Override
	public List<StaffClerkRelationDTO> listBindCodeByStaffId(List<String> enterpriseIdList, String staffId) {
		return EntityUtil.changeEntityListByJSON(StaffClerkRelationDTO.class, mapper.listBindCodeByStaffId(enterpriseIdList,staffId));
	}

	@Override
	public boolean delBind(String clerkId) {
		int i = mapper.changeStatusByClerkId(clerkId, 0);
		return i>=0;
	}

	@Override
	public boolean bind(StaffClerkRelationDTO dto) {
		dto.setStaffClerkRelationId(ToolUtil.randomUUID());
		dto.setStatusFlag(1);
		dto.setCreateTime(new Date());
		dto.setUpdateTime(new Date());

		int insert = mapper.insert(EntityUtil.changeEntityByJSON(TabHaobanStaffClerkRelation.class, dto));
		return insert>0;
	}

	@Override
	public boolean updateByClerkId(StaffClerkRelationDTO dto) {
		if (StringUtils.isAnyBlank(dto.getClerkCode(),dto.getClerkId(),dto.getStoreId())) {
			logger.info("操作不对：{}", JSONObject.toJSONString(dto));
			return false;
		}
		int i = mapper.updateByClerkId(EntityUtil.changeEntityByJSON(TabHaobanStaffClerkRelation.class, dto));
		return i>=0;
	}

	@Override
	public StaffClerkRelationDTO getBindByClerkId(String clerkId, String wxEnterpriseId) {
		TabHaobanStaffClerkRelation relation = mapper.getBindByClerkId(clerkId, wxEnterpriseId);
		return EntityUtil.changeEntityByJSON(StaffClerkRelationDTO.class,relation);
	}
	
	@Override
	public StaffClerkRelationDTO getByCodeAndEnterpriseId(String clerkCode, String enterpriseId) {
		return EntityUtil.changeEntityByJSON(StaffClerkRelationDTO.class, mapper.getByCodeAndEnterpriseId(clerkCode,enterpriseId));
	}
	@Override
	public String insert(StaffClerkRelationDTO staffClerkRelation) {
		String uuid = StringUtil.randomUUID();
		staffClerkRelation.setStaffClerkRelationId(uuid);
		staffClerkRelation.setCreateTime(new Date());
		staffClerkRelation.setUpdateTime(new Date());
		staffClerkRelation.setStatusFlag(1);
		TabHaobanStaffClerkRelation relation = EntityUtil.changeEntityByJSON(TabHaobanStaffClerkRelation.class, staffClerkRelation);
	    mapper.insert(relation);
	    return uuid;
	}
	@Override
	public int cleanStaffClerk(String wxEnterpriseId, List<String> staffIds) {
		// TODO 防报错，先提交下
		return 0;
	}
}
